/*#######################################################################################
Connect AVR to MMC/SD 

Copyright (C) 2004 Ulrich Radig
#######################################################################################*/

#ifndef _MMC_H_
 #define _MMC_H_

//If use MMC-Card then set to 1
#define	USE_MMC 			1       //EXPERIMENTAL NOT READY!!!!

#define SPI_Mode			1		//1 = Hardware SPI | 0 = Software SPI
//#define SPI_Mode			0

#define MMC_Write			PORTB	//Port an der die MMC/SD-Karte angeschlossen ist also des SPI 
#define MMC_Read			PINB
#define MMC_Direction_REG		DDRB	

#if defined (__AVR_ATmega128__)
	#define SPI_DI				3		//Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO				2		//Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock			1		//Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select		4		//Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS				0		//Nicht Benutz mu aber definiert werden
#endif

#if defined (__AVR_ATmega32__)
	#define SPI_DI				6		//Port Pin an dem Data Output der MMC/SD-Karte angeschlossen ist 
	#define SPI_DO				5		//Port Pin an dem Data Input der MMC/SD-Karte angeschlossen ist
	#define SPI_Clock			7		//Port Pin an dem die Clock der MMC/SD-Karte angeschlossen ist (clk)
	#define MMC_Chip_Select		3		//Port Pin an dem Chip Select der MMC/SD-Karte angeschlossen ist
	#define SPI_SS				4		//Nicht Benutz mu aber definiert werden
#endif

//Prototypes
inline unsigned char Read_Byte_MMC(void);
inline void Write_Byte_MMC(unsigned char);
void MMC_Read_Block(unsigned char *,unsigned char *,unsigned int);
unsigned char mmc_init(void);
unsigned char mmc_read_sector (unsigned long,unsigned char *);
unsigned char mmc_write_sector (unsigned long,unsigned char *);
unsigned char Write_Command_MMC (unsigned char *);
unsigned char Read_CSD_MMC (unsigned char *);
unsigned char Read_CID_MMC (unsigned char *);

//set MMC_Chip_Select to high (MMC/SD-Karte Inaktiv)
#define MMC_Disable() (P5OUT |= BIT0)

//set MMC_Chip_Select to low (MMC/SD-Karte Aktiv)
#define MMC_Enable() (P5OUT &= ~BIT0)

#define MMC_LOWSPEED	0
#define MMC_HIGHSPEED	1

//#define nop()  __asm__ __volatile__ ("nop" ::)

#endif //_MMC_H_


